[![PyPi](https://badge.fury.io/py/plotext.svg)](https://badge.fury.io/py/plotext)
[![GitHub stars](https://img.shields.io/github/stars/piccolomo/plotext.svg)](https://github.com/piccolomo/plotext/stargazers)
[![Downloads](https://pepy.tech/badge/plotext/month)](https://pepy.tech/project/plotext)
[![GitHubIssues](https://img.shields.io/badge/issue_tracking-github-blue.svg)](https://github.com/piccolomo/plotext/issues)
[![GitTutorial](https://img.shields.io/badge/PR-Welcome-%23FF8300.svg?)](https://github.com/piccolomo/plotext/pulls)

<p align="left">  <img src="https://raw.githubusercontent.com/piccolomo/plotext/master/data/logo.png" /></p>

`plotext` **plots directly on terminal**

- it allows for [scatter](https://github.com/piccolomo/plotext/blob/master/readme/basic.md#scatter-plot), [line](https://github.com/piccolomo/plotext/blob/master/readme/basic.md#line-plot), [bar](https://github.com/piccolomo/plotext/blob/master/readme/bar.md#simple-bar-plot), [histogram](https://github.com/piccolomo/plotext/blob/master/readme/bar.md#histogram-plot) and [date-time](https://github.com/piccolomo/plotext/blob/master/readme/datetime.md#datetime-plot) plots (including [candlestick](https://github.com/piccolomo/plotext/blob/master/readme/datetime.md#candlestick-plot)),
- it can also plot [error bars](https://github.com/piccolomo/plotext/blob/master/readme/special.md#error-plot), [confusion matrices](https://github.com/piccolomo/plotext/blob/master/readme/special.md#confusion-matrix), and add extra [text](https://github.com/piccolomo/plotext/blob/master/readme/decorator.md#text-plot), [lines](https://github.com/piccolomo/plotext/blob/master/readme/decorator.md#line-plot) and [shapes](https://github.com/piccolomo/plotext/blob/master/readme/decorator.md#shape-plot) to the plot, 
- you could use it to [plot images](https://github.com/piccolomo/plotext/blob/master/readme/image.md#image-plot) (including [GIFs](https://github.com/piccolomo/plotext/blob/master/readme/image.md#gif-plot)) and [stream video](https://github.com/piccolomo/plotext/blob/master/readme/video.md#video-plot) with audio (including [YouTube](https://github.com/piccolomo/plotext/blob/master/readme/video.md#play-youtube)),
- it can [save plots](https://github.com/piccolomo/plotext/blob/master/readme/utilities.md#canvas-utilities) as text or as colored `html`,
- it provides a simple function to [color strings](https://github.com/piccolomo/plotext/blob/master/readme/utilities.md#colored-text),
- it comes with a dedicated [command line tool](https://github.com/piccolomo/plotext/blob/master/readme/utilities.md#command-line-tool),
- it has [no dependencies](https://github.com/piccolomo/plotext/blob/bda4ac53052f750471a49f9b0ca4753aa2bdeea1/setup.py#L24) (except for optional dependencies for image/video plotting).

![subplots](https://raw.githubusercontent.com/piccolomo/plotext/master/data/subplots.png)

The **installing instructions** are [here](https://github.com/piccolomo/plotext/blob/master/readme/notes.md#install) and the image code [here](https://github.com/piccolomo/plotext/blob/master/readme/subplots.md#subplots).

---

## Guide

[Introduction](https://github.com/piccolomo/plotext/blob/master/readme/basic.md#introduction)

##### Main Plots

- [Basic Plots](https://github.com/piccolomo/plotext/blob/master/readme/basic.md)
- [Bar Plots](https://github.com/piccolomo/plotext/blob/master/readme/bar.md)
- [Datetime Plots](https://github.com/piccolomo/plotext/blob/master/readme/datetime.md)
- [Special Plots](https://github.com/piccolomo/plotext/blob/master/readme/special.md)
- [Decorator Plots](https://github.com/piccolomo/plotext/blob/master/readme/decorator.md)
- [Image Plots](https://github.com/piccolomo/plotext/blob/master/readme/image.md)
- [Play Videos](https://github.com/piccolomo/plotext/blob/master/readme/video.md)

##### Plotting  Utilities

- [Settings](https://github.com/piccolomo/plotext/blob/master/readme/settings.md)
- [Aspect](https://github.com/piccolomo/plotext/blob/master/readme/aspect.md)
- [Subplots](https://github.com/piccolomo/plotext/blob/master/readme/subplots.md#subplots)

##### Other  Resources

- [Utilities](https://github.com/piccolomo/plotext/blob/master/readme/utilities.md)
- [Environments](https://github.com/piccolomo/plotext/blob/master/readme/environments.md)
- [Notes](https://github.com/piccolomo/plotext/blob/master/readme/notes.md)

---

Some interesting [life questions](https://github.com/piccolomo/plotext/blob/master/readme/notes.md#life-questions)